Name:           bestcrypt
Version:        2.0.5
Release:        555%{?dist}
Summary:        Container Encryption Software

License:        Proprietary
URL:            http://jetico.com/
Source0:        http://jetico.com/linux/BestCrypt-2.0.5.tar.gz
Patch0:         bestcrypt-2.0-install_to_DESTDIR.patch
Patch1:         bestcrypt-2.0-spacemap-clean.patch
Patch2:         bestcrypt-2.0-no_modules_compilation.patch

Group:          Applications/File
BuildRequires:  rpm-build gcc gcc-c++ libudev-devel kernel-devel kernel-headers qt4-devel
Requires:       dosfstools kernel-devel dkms
Requires(post):  chkconfig
Requires(preun): chkconfig
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%description
BestCrypt is a container encryption software program.
Using BestCrypt you can create encrypted containers and mount them as usual disks.

%package panel
Summary:        BestCrypt Container Encryption Software
Group:          Applications/File
Requires:       bestcrypt

%description panel
BestCrypt is a container encryption software program.
Using BestCrypt you can create encrypted containers and mount them as usual disks.




%prep
%setup -q -n BestCrypt-2.0.5
%patch0 -p1
%patch1 -p1
%patch2 -p1

%build
make
make panel

%check

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT
make install panel-fake-install DESTDIR=$RPM_BUILD_ROOT

install -d -m 755 $RPM_BUILD_ROOT/%{_initddir}
install -o root -m 0755 scripts/bcrypt $RPM_BUILD_ROOT/%{_initddir}/bestcrypt

install -o root -m 0755 -d $RPM_BUILD_ROOT/%{_mandir}/man8
install -m 644 src/bctool.8 $RPM_BUILD_ROOT/%{_mandir}/man8/

%define dkms_name bestcrypt
%define dkms_vers 2.0.5
# %define quiet -q


%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add "bestcrypt"
# Add to DKMS registry
echo "Installing BestCrypt kernel modules..."
dkms add -m %{dkms_name} -v %{dkms_vers} %{?quiet} || :
# Rebuild and make available for the currenty running kernel
dkms build -m %{dkms_name} -v %{dkms_vers} %{?quiet} || :
dkms install -m %{dkms_name} -v %{dkms_vers} %{?quiet} --force || :
/sbin/service "bestcrypt" start >/dev/null 2>&1


%preun
/sbin/service "bestcrypt" stop >/dev/null 2>&1
/sbin/chkconfig --del "bestcrypt"
# Remove all versions from DKMS registry
echo "Uninstalling BestCrypt kernel modules..."
dkms remove -m %{dkms_name} -v %{dkms_vers} %{?quiet} --all || :


%files
%defattr(-,root,root,-)
%doc README HIDDEN_PART help LICENSE
%{_initddir}/*
%{_bindir}/bctool
%{_usrsrc}/*
%{_prefix}/share/applications/*
%{_prefix}/share/icons/*
%attr(4755,root,root)/sbin/bcmount_helper
%attr(4755,root,root)/sbin/bcumount_helper
%attr(4755,root,root)/sbin/bcrrpart_helper
%{_mandir}/man8/*

%files panel
%{_bindir}/bestcrypt-panel


%changelog
* Wed Jul 30 2014 Jetico Packager <packages@jetico.com> - 2.0.5
- Regular build
