#pragma once

#include "types.h"

#ifndef bc_u64
#define bc_u64 u64
#define bc_u32 u32
#define bc_u8 u8
#endif


class iVolume
{
	void * m_ctx; 
	bc_u64 m_beginPos; // map
	bc_u32 m_sectorSize;

public:
	iVolume()
	{
		m_ctx = 0;
		m_beginPos = 0;
		m_sectorSize = 512;
	}

	~iVolume()
	{
		close();
	}

	int open( const char *name, int flags );
	int close();
	s64 getSize();

	enum eResult{
		iv_Success,
		iv_IOError
	};

	virtual int readSectors( bc_u64 start_sector, bc_u8 *data, bc_u64 number_of_sectors  );
	virtual int writeSectors( bc_u64 start_sector, const bc_u8 *data, bc_u64 number_of_sectors  );
	virtual int sync();
};
