/*
 *	Copyright (c) 2012 Jetico, Inc., Finland
 *	All rights reserved.
 *
 *	String pattern comparation functions.
 */

#pragma once
#include <string.h>

/**
 *	Find last position in string of any symbol from symbols_table.
 */
static inline size_t findLast( const char *string, const char *symbols_table )
{
	size_t pos  = strlen( string );
	size_t size = strlen( symbols_table );

	while( pos-- )
	{
		for( size_t i = size; i--; )
			if( string[pos] == symbols_table[i] )
				return pos;
	}

	return pos;
}

/**
 *
 * String comparation function with *,%  symbols .
 * '*' allows group of incompatible symbols
 * '%' allows one incompatible symbol. 
 * @return     returns true if string is compatible with pattern.
 *				Example true:
 *					string  == "qwerty",
 *					pattern == "q%e*y*".
 *				Example false:
 *					string  == "qwerty",
 *					pattern == "*y%".
 */
bool equStrings( const char *strring, const char *pattern );
