/*
 * log.cpp
 *
 *  Created on: 16.07.2014
 *      Author: pav
 */

#include "log.h"
#include "FatFs/integer.h"
#include "cUString.h"
#include <stdlib.h>
#include <string.h>


int writeToLogW( const char *tag,  const char *fmt, int i, unsigned short *ws )
{
	cUString us((UTF16*)ws);
	__android_log_print(ANDROID_LOG_INFO, tag, fmt, i, us.strA() );

	return 0;
}

int writeToLog( const char *tag,  const char *fmt, int i, int j)
{
	__android_log_print(ANDROID_LOG_INFO, tag, fmt, i, j );

	return 0;
}

static char hex( unsigned char b )
{
	char ch;

	b = 0xF & b;

	if ( b <= 9 )
		ch = '0' + b;
	else
	if ( b <= 0xF)
		ch = 'A' + b - 0xA;
	else
		ch = 'X';

	return ch;
}

char *bytes2string( const unsigned char *buffer, int bufferSize, int sizeToFill, int fromBegin )
{
	if ( sizeToFill > bufferSize )
		sizeToFill = bufferSize;

	static char tmp[2048];
	memset( tmp, '.', sizeof(tmp) );

	char *str = tmp;

	int maxSize = sizeof( tmp ) / 3 - 10;

	if ( sizeToFill > maxSize )
		sizeToFill = maxSize;

	int p = 3;
	int i = 0;
	int f = sizeToFill;

	for( i=0; i<=p; i++)
	{
		str[p-i] = '0' + f % 10;
		f = f / 10;
	}

	str = (char *)tmp + p;
	*(++str) = fromBegin ? '>' : '<';
	*(++str) = ' ';
	
	tmp[sizeof(tmp) - 1 ] = 0;

	const unsigned char *bf = fromBegin ? buffer : buffer + bufferSize - sizeToFill;

	for( i = 0; i<sizeToFill; i++ )
	{
		str[i * 3] = hex( bf[i] >> 4 );
		str[i * 3 + 1 ] = hex( bf[i] );
		str[i * 3 + 2 ] = ' ';
	}

	str[ i * 3 ] = 0;

	return tmp;
}



