#include <stdio.h>
#include "../PGPPkts/pktdefs.h"
#include "../symmetricAlgs/symmetricAlgs.h"

BYTE aes256_cbc_key[32] = { 
	0x60, 0x3d, 0xeb, 0x10, 0x15, 0xca, 0x71, 0xbe, 0x2b, 0x73, 0xae, 0xf0, 0x85, 0x7d, 0x77, 0x81,
	0x1f, 0x35, 0x2c, 0x07, 0x3b, 0x61, 0x08, 0xd7,	0x2d, 0x98, 0x10, 0xa3, 0x09, 0x14, 0xdf, 0xf4};

BYTE iv[16] = {
	0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07,	0x08, 0x09, 0x0a, 0x0b, 0x0c, 0x0d, 0x0e, 0x0f};

BYTE eplain[4][16] = {
	{0x6b, 0xc1, 0xbe, 0xe2, 0x2e, 0x40, 0x9f, 0x96, 0xe9, 0x3d, 0x7e, 0x11, 0x73, 0x93, 0x17, 0x2a },
	{0xae, 0x2d, 0x8a, 0x57, 0x1e, 0x03, 0xac, 0x9c, 0x9e, 0xb7, 0x6f, 0xac, 0x45, 0xaf, 0x8e, 0x51 },
	{0x30, 0xc8, 0x1c, 0x46, 0xa3, 0x5c, 0xe4, 0x11, 0xe5, 0xfb, 0xc1, 0x19, 0x1a, 0x0a, 0x52, 0xef },
	{0xf6, 0x9f, 0x24, 0x45, 0xdf, 0x4f, 0x9b, 0x17, 0xad, 0x2b, 0x41, 0x7b, 0xe6, 0x6c, 0x37, 0x10 }};

BYTE ecipher[4][16] = {
	{0xf5, 0x8c, 0x4c, 0x04, 0xd6, 0xe5, 0xf1, 0xba, 0x77, 0x9e, 0xab, 0xfb, 0x5f, 0x7b, 0xfb, 0xd6},
	{0x9c, 0xfc, 0x4e, 0x96, 0x7e, 0xdb, 0x80, 0x8d, 0x67, 0x9f, 0x77, 0x7b, 0xc6, 0x70, 0x2c, 0x7d},
	{0x39, 0xf2, 0x33, 0x69, 0xa9, 0xd9, 0xba, 0xcf, 0xa5, 0x30, 0xe2, 0x63, 0x04, 0x23, 0x14, 0x61},
	{0xb2, 0xeb, 0x05, 0xe2, 0xc3, 0x9b, 0xe9, 0xfc, 0xda, 0x6c, 0x19, 0x07, 0x8c, 0x6a, 0x9d, 0x1b}};

BYTE dcipher[4][16] = {
	{0xf5, 0x8c, 0x4c, 0x04, 0xd6, 0xe5, 0xf1, 0xba, 0x77, 0x9e, 0xab, 0xfb, 0x5f, 0x7b, 0xfb, 0xd6},
	{0x9c, 0xfc, 0x4e, 0x96, 0x7e, 0xdb, 0x80, 0x8d, 0x67, 0x9f, 0x77, 0x7b, 0xc6, 0x70, 0x2c, 0x7d},
	{0x39, 0xf2, 0x33, 0x69, 0xa9, 0xd9, 0xba, 0xcf, 0xa5, 0x30, 0xe2, 0x63, 0x04, 0x23, 0x14, 0x61},
	{0xb2, 0xeb, 0x05, 0xe2, 0xc3, 0x9b, 0xe9, 0xfc, 0xda, 0x6c, 0x19, 0x07, 0x8c, 0x6a, 0x9d, 0x1b}};

BYTE dplain[4][16] = {
	{0x6b, 0xc1, 0xbe, 0xe2, 0x2e, 0x40, 0x9f, 0x96, 0xe9, 0x3d, 0x7e, 0x11, 0x73, 0x93, 0x17, 0x2a},
	{0xae, 0x2d, 0x8a, 0x57, 0x1e, 0x03, 0xac, 0x9c, 0x9e, 0xb7, 0x6f, 0xac, 0x45, 0xaf, 0x8e, 0x51},
	{0x30, 0xc8, 0x1c, 0x46, 0xa3, 0x5c, 0xe4, 0x11, 0xe5, 0xfb, 0xc1, 0x19, 0x1a, 0x0a, 0x52, 0xef},
	{0xf6, 0x9f, 0x24, 0x45, 0xdf, 0x4f, 0x9b, 0x17, 0xad, 0x2b, 0x41, 0x7b, 0xe6, 0x6c, 0x37, 0x10}};

int main(int argc, char **argv) 
{
	int ret, id, i, x;
	HSA	hsa = NULL;
	BYTE buf[16], *piv;

	id = bcsaRIJN;
	printf("Testing %s:\n", sa_getSymmetricAlgName(id));

	ret = sa_createAlgorithm( &hsa, id, aes256_cbc_key, 32);
	if (sae_ok != ret) {
		printf("Failed to create algorithm. Error %d\n", ret);
	}

	piv = iv;
	for (i = 0; i < 4; i++) {
		ret = sa_encryptCBC( hsa, piv, buf, eplain[i], 16);
		if (sae_ok != ret) {
			printf("Encryption test %d failed. Error %d\n", i, ret);
		} else {
			for (x = 0; x < 16; x++) {
				if (buf[x] != ecipher[i][x]) {
					printf("Encryption test %d result mismatch. At %x: result %02X, expected %02X\n", i, x, buf[x], ecipher[i][x]);
					break;
				}
			}
			if (16 == x) {
				printf("Encryption test %d passed\n", i);
			}
			piv = ecipher[i];
		}
	}

	piv = iv;
	for (i = 0; i < 4; i++) {
		ret = sa_decryptCBC( hsa, piv, buf, dcipher[i], 16);
		if (sae_ok != ret) {
			printf("Decryption test %d failed. Error %d\n", i, ret);
		} else {
			for (x = 0; x < 16; x++) {
				if (buf[x] != dplain[i][x]) {
					printf("Decryption test %d result mismatch. At %x: result %02X, expected %02X\n", i, x, buf[x], dplain[i][x]);
					break;
				}
			}
			if (16 == x) {
				printf("Decryption test %d passed\n", i);
			}
			piv = dcipher[i];
		}
	}
	sa_free(hsa);

    return 0;
}

