/*
 *  Copyright 2014 Jetico, Inc. All rights reserved.
 */

#pragma once

#define BC_FILE_ERR ((bc_u64)-1)

/**
 * List of modes that can be used while opening file.
 */
enum BCFileMode
{
    kBCFileMode_Read        = 0x01,
    kBCFileMode_ReadWrite   = 0x02,

    kBCFileMode_Exclude     = 0x10 // do not create file if it does not exist and return an error instead
};

typedef int bc_file_mode;

/**
 * List of positions from which seek operation can be performed.
 */
typedef enum
{
    kBCFileSeek_Begin       = 0,
    kBCFileSeek_Current     = 1,
    kBCFileSeek_End         = 2
} bc_file_seek;
