/*
 * Copyright 2010 Jetico, Inc. All rights reserved.
 * Linux user auth session implementation.
 */

#ifndef BC_LINUX_USER_H
#define BC_LINUX_USER_H

#include <stdlib.h>
#include <stdio.h>
#include <stdio_ext.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>
#include <assert.h>
#include <limits.h>
#include <iconv.h>
#include <locale.h>
#include <langinfo.h>
#include <termios.h>

#include "container/user.h"
#include "container/intsize.h"
#include "session.h"

#define BC_INVALID_ICONV_RESULT ((iconv_t)-1)


void BCUserMessage(const char* msg, BCUserMessageLevel level)
{
	const char* prefix = "";
	switch (level) {
	case kBCUserMessage_Warning: 
		prefix = "Warning: "; 
		break;

	case kBCUserMessage_Error:	
		prefix = "Error: ";
		break;
	
	default:
		prefix = "";
		break;
	};

	printf("%s%s\n", prefix, msg);
}

#endif // #ifndef BC_LINUX_USER_H

