//
//  Copyright 2011 Jetico, Oy. All rights reserved.
//

#ifndef __BC_AESNI_H
#define __BC_AESNI_H

#include <crypto/wintypes.h>

#define SERVICE_NAME	"BC_RIJN"
#define DISPLAY_NAME    "AES"
#define ALGORITHM_ID     0xF0

#define KEY_LENGTH 256
#define	R_BLOCK_SIZE 128
#define BLOCK_LENGTH 16

typedef struct
{
    DWORD    Nkey;       // the number of 32-bit words in the key input block
    DWORD    Nrnd;       // the number of cipher rounds
    DWORD    e_key[4 * BLOCK_LENGTH];  // the encryption key schedule
    DWORD    d_key[4 * BLOCK_LENGTH];  // the decryption key schedule
    BYTE     mode;       // encrypt, decrypt or both
} BC_AES_STRUCT;

typedef BC_AES_STRUCT plugin_key_t;

#define KEY_LENGTH_EXTENDED (sizeof(BC_AES_STRUCT) * 8)


#define IN

#ifdef __cplusplus
extern "C" {
#endif
    
    
BOOL KeyExtend(PUCHAR KeySource, PDWORD KeyDestination);
    
VOID Encrypt_ECB(BYTE* Input, BYTE* Output, BYTE* ExtendedKey);
    
VOID Decrypt_ECB(BYTE* Input, BYTE* Output, BYTE* ExtendedKey);
    
	    
#ifdef __cplusplus
}
#endif


/*
 * Plugin build defs.
 */
#define BC_PLUGIN_NAME		SERVICE_NAME
#define BC_ALGORITHM_NAME	DISPLAY_NAME
#define BC_ALGORITHM_ID		ALGORITHM_ID
#define BC_KEY_LENGTH		KEY_LENGTH
#define BC_BLOCK_SIZE		BLOCK_LENGTH
#define BC_EXTENDED_KEY_SIZE	sizeof(BC_AES_STRUCT)
#define BC_ALGORITHM_NO_CBC 1

#endif
