/*
 *  Copyright 2010 Jetico, Inc. All rights reserved.
 *
 */

#ifndef BC_KERNEL_LIST_H
#define BC_KERNEL_LIST_H


typedef struct bc_list_node {
	bc_list_node* next;
	bc_list_node* prev;
} bc_list_node;


#define BC_LIST_ELEMENT(elem_type, node_addr, node_field) \
	((elem_type *) (((char*)node_addr) - (((char*)(&(((elem_type *)1)->node_field)))-1)))


typedef struct {
	bc_list_node	head;
} bc_list;


static inline void bc_list_init(bc_list* list) {
	list->head.next = &list->head;
	list->head.prev = &list->head;
}


static inline void bc_list_free(bc_list* list) {
	list->head.next = list->head.prev = NULL;
}


static inline void bc_list_insert(bc_list* list, bc_list_node* node) {
	node->next = list->head.next;
	node->prev = &list->head;
	list->head.next = node;
}


static inline void bc_list_remove(bc_list* list, bc_list_node* node) {
	bc_list_node* prev = node->prev;
	bc_list_node* next = node->next;
	
	prev->next = next;
	next->prev = prev;
	
	node->prev = node->next = NULL;
}


#endif
