/*
 * Copyright 2010 Jetico, Inc. All rights reserved.
 *
 * Utility types for scope rw locking.
 */

#ifndef BC_KERNEL_SCOPE_LOCK_H
#define BC_KERNEL_SCOPE_LOCK_H

#include <IOKit/IOLocks.h>

// Lock scope for reading.
class BCScopeReadLock {
public:
	BCScopeReadLock(IORWLock* lock) : m_lock(lock) {
		IORWLockRead(m_lock);
	}
	
	~BCScopeReadLock() {
		IORWLockUnlock(m_lock);
		m_lock = NULL;
	}
	
private:
	IORWLock* m_lock;
};


// Lock scope for writing.
class BCScopeWriteLock {
public:
	BCScopeWriteLock(IORWLock* lock) : m_lock(lock) {
		IORWLockWrite(m_lock);
	}
	
	~BCScopeWriteLock() {
		IORWLockUnlock(m_lock);
		m_lock = NULL;
	}
	
private:
	IORWLock* m_lock;
};

#endif
