/*
 *  Copyright 2010 Jetico, Inc. All rights reserved.
 *
 */

#include "BCKernel.h"
#include <stdio.h>
#include <string.h>

static char data[kBCKernel_BlockSize] = {0};
static uint64_t iv = 0;
static char pool[kBCKernel_PoolSize] = {0};
static char key[64] = {0};

int bc_test_noop()
{
	int rc;
	
	bc_alg noop;
	rc = bc_kernel_lookup_alg_name("NOOP", &noop);
	if(kBCKernel_Success != rc) {
		printf("NOOP lookup failed: %d\n", rc);
		return -1;
	}
	
	char buf[kBCKernel_BlockSize];
	memcpy(buf, data, sizeof(data));
	
	rc = bc_kernel_process_with_key(noop.id, kBCMode_NOOP, kBCProcess_Encrypt, key, sizeof(key), iv, pool, buf, sizeof(buf));
	if(kBCKernel_Success != rc) {
		printf("Failed encrypting: %s\n", bc_kernel_perror(rc));
		return 0;
	}
	
	if(0 != memcmp(buf, data, sizeof(data))) {
		printf("Encryption test failed\n");
		return 0;
	}
	
	rc = bc_kernel_process_with_key(noop.id, kBCMode_NOOP, kBCProcess_Decrypt, key, sizeof(key), iv, pool, buf, sizeof(buf));
	if(kBCKernel_Success != rc) {
		printf("Failed decrypting: %s\n", bc_kernel_perror(rc));
		return 0;
	}
	
	if(0 != memcmp(buf, data, sizeof(data))) {
		printf("Decryption test failed\n");
		return 0;
	}
	
	return 1;
}

	
	

