/*
 *  Copyright 2010 Jetico, Inc. All rights reserved.
 *
 */

#ifndef BC_CRYPTO_TEST_H
#define BC_CRYPTO_TEST_H


/// Plaintext test data. Common for all tests.
typedef struct {
	size_t		nbytes;
	unsigned char*	plaintext;
	uint64_t	iv;
	unsigned char*	pool;
} bc_test_data;


/// Test check data.
typedef struct {
	size_t		nbytes;
	unsigned char*	ciphertext;
	size_t		keysize;
	unsigned char*	key;
} bc_test_vector;


int bc_load_test_data(const char* file, bc_test_data* out_test);


void bc_free_test_data(bc_test_data* data);


#endif
