/*
 *	Copyright (c) 2012 Jetico, Inc., Finland
 *	All rights reserved.
 *
 *  Password based key block encoding and decoding
 */

#ifndef KGGHOST_PBE_H
#define KGGHOST_PBE_H

#include "keyblock.h"

namespace kgghost {

    // Encode key into key block using password
    unsigned pbe_encode(const key_data_t* key, const BCPassword* pwd,
				CipherBase* cipher, bc_u8* kb_data, unsigned kbsize);
    
    // Decode key from key block using password
    unsigned pbe_decode(const bc_u8* kbdata, unsigned kbsize, const BCPassword* pwd,
				CipherBase* cipher, int hash, key_data_t* out_key);

    // Verify password without decoding the key
    bool pbe_verify(const bc_u8* kbdata, unsigned kbsize, const BCPassword* pwd,
				CipherBase* cipher, int hash);

	unsigned getPBEBlockSize( const key_data_t* key );
}

#endif

