/*
 *	Copyright (c) 2012 Jetico, Inc., Finland
 *	All rights reserved.
 *
 *  Shamir shared scheme key block encoding and decoding
 */

#ifndef KGGHOST_SSS_H
#define KGGHOST_SSS_H

#include "keyblock.h"

namespace kgghost {

    // Encode key into key block using password
    unsigned sss_encode(const key_data_t* key, const BCPassword* pwd, bc_u8* kb_data, unsigned kbsize);
    
    // Decode key from key block using password
    unsigned sss_decode(const bc_u8* kbdata, unsigned kbsize, const BCPassword* pwd,
                        CipherBase* cipher, int hash, key_data_t* out_key);

    // Verify password without decoding the key
    bool sss_verify(const bc_u8* kbdata, unsigned kbsize, const BCPassword* pwd,
                    CipherBase* cipher, int hash);

}

#endif // KGGHOST_SSS_H