/*
 * Copyright (c) 2012 Jetico, Inc., Finland
 * All rights reserved.
 */

#ifndef DEFS_H
#define DEFS_H

#include "../container/intsize.h"

#ifdef _WIN32

#include <windows.h>

#else
#ifdef BC_KERNEL // Linux, kernel-space level.

#define _NO_VERSION_

#include <linux/init.h>
#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/slab.h>
#include <asm/uaccess.h>

#define FREE(p) kfree(p)
#define ALLOC(size) kmalloc(size, GFP_KERNEL)
#define PRINT(msg, args...) printk(KERN_ERR "bestcrypt: " msg, ##args)

#else // Linux, user-space level.

#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>

#ifndef __cplusplus
    #define bool int
    #define true 1
    #define false 0
#endif

#define FREE(p) free(p)
#define ALLOC(size) malloc(size)
#define PRINT(msg, args...) fprintf(stderr, msg, ## args);

#endif // BC_KERNEL
#endif // else

#endif // DEFS_H
