/*
 * Copyright (c) 2012 Jetico, Inc., Finland
 * All rights reserved.
 *
 * Revision:
 *	Windows Visual Studio C++ does not recognise bool, false, inline if file has .c extention, but properly works for .cc or .cpp files
 */

#include "extent.h"

_Bool ExtentUnion(Extent *result, const Extent *e1, const Extent *e2)
{
    bc_u64 start, end;

    if (ExtentAreIntersecting(e1, e2))
    {
        start = ExtentStart(e1) < ExtentStart(e2) ? ExtentStart(e1) : ExtentStart(e2);
        end = ExtentEnd(e1) > ExtentEnd(e2) ? ExtentEnd(e1) : ExtentEnd(e2);
        result->start = start;
        result->length = end - start + 1;
        return _bTrue;
    }

    return _bFalse;
}

