/*
 * Copyright 2012 Jetico, Inc. All rights reserved.
 * Help conversion functions.
 */
#pragma once

#include "ConvertUTF.h"

#ifdef __cplusplus
extern "C" {
#endif

	/**
	 *	Calculate conversion size.
	 *	@param utf8bf    utf8 buffer for convertion
	 *	@param size      buffer size 
	 *	@param flags     strictConversion = 0 ( do not change invalid symbols ), lenientConversion = 1 ( change invalid symbols to default )
	 *	@return          size in bytes of required output buffer for convertion
	 */
	unsigned int getSizeUTF8toUTF16( const UTF8* utf8bf, unsigned int size, ConversionFlags flags );
	unsigned int getSizeUTF16toUTF8( const UTF16* utf16bf, unsigned int size, ConversionFlags flags );

	/**
	 *	Calculate conversion size.
	 *	@param in_utf8   input UTF8 string for convertion
	 *	@param inlen     input string length 
	 *	@param out_utf16 output utf8 string for convertion
	 *	@param outlen    output string length in UTF16 symbols
	 *	@return          size in UTF16 symbols of required output buffer for convertion
	 */
	unsigned int convertUTF8toUTF16( const UTF8* in_utf8, unsigned int inlen, UTF16 *out_utf16, unsigned int outlen );
	unsigned int convertUTF16toUTF8( const UTF16* in_utf16, unsigned int inlen, UTF8 *out_utf8, unsigned int outlen );

#ifdef __cplusplus
}
#endif
