QT              += core gui

CONFIG(debug, debug|release) {
    DEFINES += BC_DEBUG
}


DEFINES         += BC_LINUX BC_LINUX_GUI \
                    _LARGE_FILES _LARGEFILE_SOURCE \
                    _LARGEFILE64_SOURCE _FILE_OFFSET_BITS=64

TARGET          = bestcrypt-panel

TEMPLATE        = app

INCLUDEPATH     += ./widget \
                   ../ \
                   ../src \
                   ../libs/multi-lib \
                   ../libs/multi-lib/container

LIBS            += -ludev -lX11

SOURCES         += main.cpp \
                mainwindow.cpp \
                reencryptdialog.cpp \
                selectcipherwidget.cpp \
                filesystemwidget.cpp \
                formatdialog.cpp \
                logdialog.cpp \
                model/logging.cpp \
                rawlinkdialog.cpp \
                operations/bcoperation.cpp \
                model/hotkeylistener.cpp \
                model/devicemonitor.cpp \
                containerinfowidget.cpp \
                maintoolbarwidget.cpp \
                containertreewidget.cpp \
                dialogs/ContainerMountDialog.cpp \
                dialogs/keyfilesdialog.cpp \
                entity/settings.cpp \
                entity/containerdescriptor.cpp \
                settingsdialog.cpp \
                hotkeydialog.cpp \
                entity/hotkey.cpp \
                trayiconmanager.cpp \
                bcapplication.cpp \
                aboutdialog.cpp \
                container/user.cc \
                ../kernel/BCKernel.cc \
                ../src/disk/disk.cc \
                ../src/bctool-umount.cpp \
                ../src/bctool-reencrypt.cpp \
                ../src/bctool-rawlink.cpp \
                ../src/bctool-new.cpp \
                ../src/bctool-mount.cpp \
                ../src/bctool-link.cpp \
                ../src/bctool-hidden.cpp \
                ../src/bctool-benchmark.cpp \
                ../src/bctool.cpp \
                ../src/StringUtils.cpp \
                ../src/FilesystemUtils.cpp \
                ../src/container/BCFileChannel.cpp \
                ../libs/multi-lib/container/isaac64.cpp \
                ../libs/multi-lib/container/linux/file.cpp \
                ../libs/multi-lib/container/volume.cpp \
                ../libs/multi-lib/container/isaac.c \
                ../libs/multi-lib/container/container.cpp \
                ../libs/multi-lib/container/cipherbase.cpp \
                ../libs/multi-lib/container/cipher_kernel.cpp \
                ../libs/multi-lib/container/password.cpp \
                ../libs/multi-lib/container/encmode/bc_alg.cpp \
                ../libs/multi-lib/container/encmode/gf_mul.c \
                ../libs/multi-lib/keygens/keyFiles.cpp \
                ../libs/multi-lib/spacemap/extent.cpp \
                ../libs/multi-lib/spacemap/spacemap.cpp \
                ../libs/multi-lib/spacemap/spacemap_extra.c \
                ../libs/multi-lib/utf8-utf16/ConvertUTF.c \
                ../libs/multi-lib/utf8-utf16/convertUTFSize.c \
    dialogs/ContainerAccessDialog.cpp \
    model/KeyFilesModel.cpp \
    welcomewidget.cpp \
    model/containerlistmodel.cpp \
    containerlistitem.cpp \
    operations/MountWorker.cpp \
    operations/BackgroundJob.cpp \
    operations/MountController.cpp \
    operations/QtBCTool.cpp \
    operations/Worker.cpp \
    dialogs/ContainerCreateDialog.cpp \
    operations/CreationWorker.cpp \
    operations/CreationController.cpp \
    operations/HiddenCreateController.cpp \
    dialogs/HiddenCreateDialog.cpp \
    operations/HiddenCreateWorker.cpp \
    dialogs/AssignPasswordDialog.cpp \
    operations/QtPwdGet.cpp \
    dialogs/QtPwdGetGlue.cpp \
    operations/AddPasswordController.cpp \
    operations/AddPasswordWorker.cpp \
    operations/ChangePasswordController.cpp \
    operations/ChangePasswordWorker.cpp \
    operations/RemovePasswordController.cpp \
    operations/RemovePasswordWorker.cpp \
    operations/WipeHeaderController.cpp \
    operations/WipeHeaderWorker.cpp \
    operations/EncryptHeaderController.cpp \
    operations/EncryptHeaderWorker.cpp \
    ../src/bctool-header.cpp \
    operations/DecryptHeaderController.cpp \
    operations/DecryptHeaderWorker.cpp \
    operations/BackupHeaderController.cpp \
    operations/BackupHeaderWorker.cpp \
    dialogs/BackupHeaderDialog.cpp \
    dialogs/RestoreHeaderDialog.cpp \
    operations/RestoreHeaderController.cpp \
    operations/RestoreHeaderWorker.cpp \
    operations/ChangeDescriptionWorker.cpp \
    operations/ChangeDescriptionController.cpp \
    dialogs/ChangeDescriptionDialog.cpp \
    operations/QtCertlibProgressActor.cpp \
    operations/LinkController.cpp \
    operations/LinkWorker.cpp \
    model/qt_helpers.cpp \
    CommandLineArgsProcessor.cpp


HEADERS         += \
                ../libs/multi-lib/container/user.h \
                ../libs/multi-lib/kernel/BCKernel.h \
                ../src/version.h \
                ../libs/multi-lib/container/volume.h \
                ../libs/multi-lib/container/keygen.h \
                ../libs/multi-lib/container/container.h \
                ../libs/multi-lib/container/cipherbase.h \
                entity/containerdescriptor.h \
                ../libs/multi-lib/container/exception.h \
                operations/bcoperation.h \
                ../src/disk/disk.h \
                ../libs/multi-lib/container/error.h \
                ../src/bctool.h \
                ../src/StringUtils.h \
                ../src/FilesystemUtils.h \
                ../src/container/BCFileChannel.h \
                ../libs/multi-lib/container/isaac.h \
                dialogs/ContainerMountDialog.h \
                mainwindow.h \
                maintoolbarwidget.h \
                containertreewidget.h \
                containerinfowidget.h \
                entity/settings.h \
                settingsdialog.h \
                hotkeydialog.h \
                entity/hotkey.h \
                model/hotkeylistener.h \
                trayiconmanager.h \
                bcapplication.h \
                aboutdialog.h \
                model/devicemonitor.h \
    ../libs/multi-lib/spacemap/spacemap.h \
    ../libs/multi-lib/spacemap/extent.h \
    ../libs/multi-lib/spacemap/defs.h \
    ../libs/multi-lib/container/standard.h \
    ../libs/multi-lib/container/helpers.h \
    ../libs/multi-lib/container/isaac64.h \
    reencryptdialog.h \
    selectcipherwidget.h \
    filesystemwidget.h \
    formatdialog.h \
    logdialog.h \
    model/logging.h \
    rawlinkdialog.h \
    dialogs/keyfilesdialog.h \
    dialogs/ContainerAccessDialog.h \
    model/KeyFilesModel.h \
    welcomewidget.h \
    model/containerlistmodel.h \
    containerlistitem.h \
    operations/MountWorker.h \
    operations/BackgroundJob.h \
    operations/MountController.h \
    operations/QtBCTool.h \
    operations/Worker.h \
    dialogs/ContainerCreateDialog.h \
    operations/CreationWorker.h \
    operations/CreationController.h \
    operations/HiddenCreateController.h \
    dialogs/HiddenCreateDialog.h \
    operations/HiddenCreateWorker.h \
    dialogs/AssignPasswordDialog.h \
    operations/QtPwdGet.h \
    dialogs/QtPwdGetGlue.h \
    operations/AddPasswordController.h \
    operations/AddPasswordWorker.h \
    operations/ChangePasswordController.h \
    operations/ChangePasswordWorker.h \
    operations/RemovePasswordController.h \
    operations/RemovePasswordWorker.h \
    operations/WipeHeaderController.h \
    operations/WipeHeaderWorker.h \
    operations/EncryptHeaderController.h \
    operations/EncryptHeaderWorker.h \
    operations/DecryptHeaderController.h \
    operations/DecryptHeaderWorker.h \
    operations/BackupHeaderController.h \
    operations/BackupHeaderWorker.h \
    dialogs/BackupHeaderDialog.h \
    dialogs/RestoreHeaderDialog.h \
    operations/RestoreHeaderController.h \
    operations/RestoreHeaderWorker.h \
    operations/ChangeDescriptionWorker.h \
    operations/ChangeDescriptionController.h \
    dialogs/ChangeDescriptionDialog.h \
    operations/QtCertlibProgressActor.h \
    operations/LinkController.h \
    operations/LinkWorker.h \
    model/qt_helpers.h \
    CommandLineArgsProcessor.h

FORMS           += mainwindow.ui \
                containerinfowidget.ui \
                maintoolbarwidget.ui \
                containertreewidget.ui \
                dialogs/ContainerMountDialog.ui \
                settingsdialog.ui \
                hotkeydialog.ui \
                aboutdialog.ui \
    reencryptdialog.ui \
    selectcipherwidget.ui \
    filesystemwidget.ui \
    formatdialog.ui \
    logdialog.ui \
    rawlinkdialog.ui \
    dialogs/keyfilesdialog.ui \
    dialogs/ContainerAccessDialog.ui \
    welcomewidget.ui \
    containerlistitem.ui \
    dialogs/ContainerCreateDialog.ui \
    dialogs/HiddenCreateDialog.ui \
    dialogs/AssignPasswordDialog.ui \
    dialogs/BackupHeaderDialog.ui \
    dialogs/RestoreHeaderDialog.ui \
    dialogs/ChangeDescriptionDialog.ui

RESOURCES       += \
                ./res/BCToolGUIResources.qrc

OTHER_FILES += \
    jbc-mime.xml \
    filetype-register.sh


# TODO: read qmake manual and fix resulting 'Makefile' that it will build all of these libraries automatically if needed:
#       (currently you have to execute all the '.commands' before)

kgsha_lib = ../libs/multi-lib/keygens/kgsha/libkgsha.a
kgsha.target = libkgsha
kgsha.commands = cd ../libs/multi-lib/keygens/kgsha && make -f Makefile
kgsha_clean.commands = cd ../libs/multi-lib/keygens/kgsha && make -f Makefile clean

kgghost_lib = ../libs/multi-lib/keygens/kgghost/libkgghost.a
kgghost.target = libkgghost
kgghost.commands = cd ../libs/multi-lib/keygens/kgghost && make -f Makefile
kgghost_clean.commands = cd ../libs/multi-lib/keygens/kgghost && make -f Makefile clean

fslib_lib = ../libs/multi-lib/fslib/libfslib.a
fslib.target = libfslib
fslib.commands = cd ../libs/multi-lib/fslib && make -f Makefile
fslib_clean.commands = cd ../libs/multi-lib/fslib && make -f Makefile clean

certificate_lib = ../libs/multi-lib/certificate/CertificateLib/libcertificate.a
certificate.target = libcertificate
certificate.commands = cd ../libs/multi-lib/certificate/CertificateLib && make -f Makefile
certificate__clean.commands = cd ../libs/multi-lib/certificate/CertificateLib && make -f Makefile clean

LIBS += \
  ../libs/multi-lib/keygens/kgghost/libkgghost.a \
  ../libs/multi-lib/keygens/kgsha/libkgsha.a \
  ../libs/multi-lib/certificate/CertificateLib/libcertificate.a \
  ../libs/multi-lib/fslib/libfslib.a

QT_EXTRA_TARGETS += libkgsha libkgghost libfslib libcertificate
