#ifndef CONTAINERINFOWIDGET_H
#define CONTAINERINFOWIDGET_H

#include <QWidget>

class ContainerDescriptor;
class QTimer;

namespace Ui {
class ContainerInfoWidget;
}

class ContainerInfoWidget : public QWidget
{
    Q_OBJECT
    
public:
    explicit ContainerInfoWidget(ContainerDescriptor *d);
    ~ContainerInfoWidget();


public slots:
    void onUpdate();

    void onShowError(QString error);
    void onProgress(QString text, int n, int m);
    void onBGJobFinished(bool success);

signals:
    void edit_description();
    void cancel();

protected:

private slots:
    void onOpenLocationSlot();
    void onStopProgressbar();

private:
    Ui::ContainerInfoWidget *ui;
    ContainerDescriptor *descriptor;
    QTimer *job_finished_timer;
};

#endif // CONTAINERINFOWIDGET_H
