#ifndef CONTAINERVIEW_H
#define CONTAINERVIEW_H

#include <QWidget>

namespace Ui {
class ContainerView;
}

class ContainerDescriptor;

/*! One container item in container list widget on the left.
 * TODO: use Qt Model/View framework here (QListView class)
 */
class ContainerListItem : public QWidget
{
    Q_OBJECT
    
public:
    explicit ContainerListItem(QWidget *parent, ContainerDescriptor *d);
    ~ContainerListItem();

    ContainerDescriptor *GetDescriptor() const { return this->descriptor; }

    void Select();

    void Deselect();

    bool IsSelected()  { return this->isSelected_; }


    void paintEvent(QPaintEvent *);
    void mouseDoubleClickEvent(QMouseEvent *);
    void keyPressEvent(QKeyEvent *);

signals:
    void OnSelected(ContainerListItem* w);
    void OnEject(ContainerListItem *w);
    void OnMount(ContainerListItem *w);
    void OnSelectNext(ContainerListItem *w);
    void OnSelectPrevious(ContainerListItem *w);

protected:
    void mousePressEvent(QMouseEvent *);

private:
    Ui::ContainerView *ui;
    ContainerDescriptor *descriptor;
    bool isSelected_;

private slots:
    void onUpdate();
    void EjectClickSlot();
};

#endif // CONTAINERVIEW_H
