#ifndef CONTAINERTREEWIDGET_H
#define CONTAINERTREEWIDGET_H

#include "containerlistitem.h"

#include <QWidget>

namespace Ui {
class ContainerTreeWidget;
}

class ContainerListModel;
class ContainerDescriptor;

class ContainerTreeWidget : public QWidget
{
    Q_OBJECT
    
public:
    explicit ContainerTreeWidget(QWidget *parent = 0);
    ~ContainerTreeWidget();

    void InitModel(ContainerListModel *model);

    ContainerDescriptor *GetSelectedDescriptor()
    {
        if (this->selectedView_)
            return this->selectedView_->GetDescriptor();
        return 0;
    }

    // bool SelectContainer(const QString& fullPath);
    bool SelectDescriptor(ContainerDescriptor *descriptor);

signals:
    void OnSelectedDescriptorChanged(ContainerDescriptor *descriptor);
    void OnEject();
    void OnMount();
    void OnDelete();

protected:
    void keyPressEvent(QKeyEvent *event);

private slots:
    void SelectedViewChangedSlot(ContainerListItem *view);
    void SelectedViewEjectClickedSlot(ContainerListItem *view);
    void SelectedViewMountClickedSlot(ContainerListItem *);
    void SelectedViewSelectNextSlot(ContainerListItem *view);
    void SelectedViewSelectPreviousSlot(ContainerListItem *view);
    void DataChangedSlot();
    void ClearButtonClickSlot();

    void on_removeToolButton_clicked();
    
private:
    Ui::ContainerTreeWidget     *ui;

    ContainerListModel              *containerModel_;
    QList<ContainerListItem *>      *containerViews_;
    ContainerListItem               *selectedView_;
    QAction                     *deleteFileAction_;
    QAction                     *clearListAction_;

    void SelectView(ContainerListItem *view);
    void UpdateViewList();
    void SelectContainerByIndex(int index);
};

#endif // CONTAINERTREEWIDGET_H
