#ifndef BACKUPHEADERDIALOG_H
#define BACKUPHEADERDIALOG_H

#include <QDialog>
#include <QStringList>

#include "QtPwdGetGlue.h"

namespace Ui {
class BackupHeaderDialog;
}

class BCToolHeaderParams;

class BackupHeaderDialog : public QDialog, public QtPwdGetGlue::PasswordProvider
{
    Q_OBJECT
    
public:
    explicit BackupHeaderDialog(QWidget *parent, BCToolHeaderParams *hp);
    ~BackupHeaderDialog();

    void setTitle(const char *query, bool prev_failed = false);

    void setFilename(const QString &path);

    void savePasswordBundleTo(QtPwdGet *pwdGet) const;

private slots:
    void on_keyFilesButton_clicked();

    void on_passwordEdit_textChanged(const QString &arg1);

    void on_browseBtn_clicked();
    
private:
    Ui::BackupHeaderDialog *ui;
    QStringList keyfiles;
    BCToolHeaderParams *headerParams;
};

#endif // BACKUPHEADERDIALOG_H
