#ifndef CONTAINERACCESSDIALOG_H
#define CONTAINERACCESSDIALOG_H

#include <QDialog>
#include <QStringList>
#include "QtPwdGetGlue.h"

namespace Ui {
class ContainerAccessDialog;
}

class ContainerAccessDialog : public QDialog, public QtPwdGetGlue::PasswordProvider
{
    Q_OBJECT
    
public:
    explicit ContainerAccessDialog(QWidget *parent = 0);
    ~ContainerAccessDialog();

    void setTitle(const char *query, bool prev_failed = false);

    void setFilename(const QString &path);

    void savePasswordBundleTo(QtPwdGet *pwdGet) const;

    void enableAskMore();
    bool needToAskMore() const;

    void setTextNote(const std::string &txt);

    void clear();

private slots:
    void on_keyFilesButton_clicked();

    void on_passwordEdit_textChanged(const QString &arg1);

    void onAdvancedTrigger();

    void on_AdvancedTrigger_linkActivated(const QString &link);

private:
    Ui::ContainerAccessDialog *ui;
    QStringList keyfiles;
};

#endif // CONTAINERACCESSDIALOG_H
