#ifndef CONTAINERMOUNTDIALOG_H
#define CONTAINERMOUNTDIALOG_H

#include <QDialog>
#include <QMainWindow>
#include "QtPwdGetGlue.h"

namespace Ui {
class ContainerMountDialog;
}

class BCToolMountParams;
class QtPwdGet;
class QTimer;

class ContainerMountDialog : public QDialog, public QtPwdGetGlue::PasswordProvider
{
    Q_OBJECT

public:
    explicit ContainerMountDialog(QWidget *parent, BCToolMountParams *mp);
    ~ContainerMountDialog();

    void setTitle(const char *query, bool prev_failed);

    // dialog's output
    void savePasswordBundleTo(QtPwdGet *pwdGet) const;

    // TODO: resetError() pair method or remove and use just ui->errorLabel->setText()
    void showError(const QString& error);

private slots:
    void onPassTextChangedSlot();
    void onAdvancedSettingsToggle();

    void on_mountLocationButton_clicked();
    void on_keyFilesButton_clicked();
    void on_mountPointText_textChanged(const QString &arg1);
    
    void on_keyblockBrowseButton_clicked();
    
    void on_okButton_clicked();
    
private:
    Ui::ContainerMountDialog *ui;
    QStringList keyfiles;
    BCToolMountParams *mountParams;
    QTimer *dlg_close_timer;

    void setParamsFrom(const BCToolMountParams *mountParams);
    void dumpParamsTo(BCToolMountParams *mountParams);
};

#endif // CONTAINERMOUNTDIALOG_H
