#ifndef QTPWDGETGLUE_H
#define QTPWDGETGLUE_H

#include <QObject>

class QDialog;
class QtPwdGet;

//! Connects PasswordProvider-derived Dialog and QtPwdGet object
class QtPwdGetGlue : public QObject
{
    Q_OBJECT
public:
    explicit QtPwdGetGlue(QObject *parent, QDialog *dlg, QtPwdGet *pwdGet);

    /** @brief Mix-in interface class for dialogs which interacts with QtPwdGet
     * (tighted together by QtPwdGetGlue object)
     */
    class PasswordProvider
    {
    public:
        PasswordProvider() {}
        virtual ~PasswordProvider() {}

        virtual bool havePasswordAlready() const { return false; }
        virtual void savePasswordBundleTo(QtPwdGet *pwdGet) const = 0;
        virtual void setTitle(const char *query, bool prev_failed = false) = 0;
        virtual bool needToAskMore() const { return false; }
        virtual void setTextNote(const std::string &txt) {}
    };

protected slots:
    virtual void onNeedPassword(bool prev_failed);

private slots:
    void onDlgAccepted();
    void onDlgRejected();

private:
    QDialog  *dialog;
    QtPwdGet *pwdGet;
};

#endif // QTPWDGETGLUE_H
