#ifndef RESTOREHEADERDIALOG_H
#define RESTOREHEADERDIALOG_H

#include <QDialog>
#include <QStringList>

#include "QtPwdGetGlue.h"

namespace Ui {
class RestoreHeaderDialog;
}

class BCToolHeaderParams;

class RestoreHeaderDialog : public QDialog, public QtPwdGetGlue::PasswordProvider
{
    Q_OBJECT
    
public:
    explicit RestoreHeaderDialog(QWidget *parent, BCToolHeaderParams *hp);
    ~RestoreHeaderDialog();

    void setTitle(const char *query, bool prev_failed = false);

    void setFilename(const QString &path);

    bool havePasswordAlready() const;

    void savePasswordBundleTo(QtPwdGet *pwdGet) const;


private slots:
    void on_keyFilesButton_clicked();

    void on_passwordEdit_textChanged(const QString &arg1);

    void on_browseBtn_clicked();

private:
    Ui::RestoreHeaderDialog *ui;
    QStringList keyfiles;
    BCToolHeaderParams *headerParams;
};

#endif // RESTOREHEADERDIALOG_H
