#include <QFileDialog>

#include "keyfilesdialog.h"
#include "ui_keyfilesdialog.h"
#include "model/KeyFilesModel.h"


keyfilesdialog::keyfilesdialog(QWidget *parent, const QStringList &keyfiles) :
    QDialog(parent),
    ui(new Ui::keyfilesdialog)
{
    ui->setupUi(this);

    model = new KeyFilesModel();
    ui->keyfilesView->setModel(model);

    for (int i = 0 ; i < keyfiles.count() ; i++)
        model->appendFile(keyfiles[i]);

#ifndef BC_DEBUG
    // TODO: implement them in 3.1.0 (#2678)
    ui->addFolderButton->setVisible(false);
    ui->removeButton->setVisible(false);
#endif
}

keyfilesdialog::~keyfilesdialog()
{
    delete ui;
    delete model;
}


void keyfilesdialog::on_addFilesButton_clicked()
{
    QFileDialog d;
    d.setFileMode(QFileDialog::ExistingFiles);
    // d.setOptions(QFileDialog::ShowDirsOnly);

    if (d.exec() == QDialog::Accepted)
    {
        QStringList selectedFiles = d.selectedFiles();

        for (int i = 0; i < selectedFiles.size(); ++i) {
            model->appendFile(selectedFiles[i]);
        }
    }
}


QStringList keyfilesdialog::getKeyFiles() const
{
    return model->keyFiles();
}


QString keyfilesdialog::getButtonCaption(int n) const
{
   return QString("Key Files (%1)").arg(n);
}


#if 0  //    - doesn't work properly
void keyfilesdialog::resizeEvent(QResizeEvent *event)
{
    ui->keyfilesView->setColumnWidth(0, ui->keyfilesView->width() * 0.8);
    ui->keyfilesView->setColumnWidth(1, ui->keyfilesView->width() * 0.2);
    QDialog::resizeEvent(event);
}
#endif


void keyfilesdialog::on_clearListButton_clicked()
{
    model->clear();
}


void keyfilesdialog::on_removeButton_clicked()
{
    
}


void keyfilesdialog::on_addFolderButton_clicked()
{
    
}
