#include <QtGui/QApplication>
#include <QtGui/QMessageBox>

#include <fcntl.h>
#include <sys/stat.h>
#include <semaphore.h>

#include "mainwindow.h"
#include "src/version.h"
#include "bcapplication.h"

#include "container/user.h"
#include "model/logging.h"
#include "CommandLineArgsProcessor.h"
#include "QTimer"

const char *PROG_NAME = "bestcrypt-gui";

int main(int argc, char *argv[])
{
    // commented out because it makes output in 'Application Output' invisible
    // TODO: duplicate the output to stderr/stdout and internal storage
    // BCLogStart();

    QCoreApplication::setOrganizationName(BC_VENDOR);
    QCoreApplication::setOrganizationDomain(BC_DOMAIN);
    QCoreApplication::setApplicationName(BC_GUI_APP_NAME);

    BCApplication a(argc, argv);
    a.setQuitOnLastWindowClosed(false);

    // Check if we need to process some files.
    if (a.arguments().size() > 1)
    {
        // Process specified in command line files and exit
        CommandLineArgsProcessor ap(a.arguments());
        QTimer::singleShot(100, &ap, SLOT(take_one()));
        return a.exec();
    }

    // Check that only one instance is running.
    a.CheckOneInstance();

    MainWindow w;
    w.show();

    return a.exec();
}
