#include "maintoolbarwidget.h"
#include "ui_maintoolbarwidget.h"

MainToolbarWidget::MainToolbarWidget(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::MainToolbarWidget)
{
    ui->setupUi(this);

    connect(this->ui->createToolButton, SIGNAL(clicked()), this, SLOT(CreateClickedSlot()));
    connect(this->ui->locateToolButton, SIGNAL(clicked()), this, SLOT(BrowseClickedSlot()));
    connect(this->ui->mountToolButton, SIGNAL(clicked()), this, SLOT(MountClickedSlot()));
    connect(this->ui->ejectToolButton, SIGNAL(clicked()), this, SLOT(EjectClickedSlot()));
    connect(this->ui->ejectAllToolButton, SIGNAL(clicked()), this, SLOT(EjectAllClickedSlot()));
    connect(this->ui->forceEjectToolButton, SIGNAL(clicked()), this, SLOT(EjectForceClickedSlot()));
}

MainToolbarWidget::~MainToolbarWidget()
{
    delete ui;
}

void MainToolbarWidget::SetMountEnabled(bool enabled)
{
    this->ui->mountToolButton->setEnabled(enabled);
}

void MainToolbarWidget::SetEjectEnabled(bool enabled)
{
    this->ui->ejectToolButton->setEnabled(enabled);
    this->ui->forceEjectToolButton->setEnabled(enabled);
}

void MainToolbarWidget::SetEjectAllEnabled(bool enabled)
{
    this->ui->ejectAllToolButton->setEnabled(enabled);
}

void MainToolbarWidget::CreateClickedSlot()
{
    emit this->OnCreate();
}

void MainToolbarWidget::BrowseClickedSlot()
{
    emit this->OnBrowse();
}

void MainToolbarWidget::MountClickedSlot()
{
    emit this->OnMount();
}

void MainToolbarWidget::EjectClickedSlot()
{
    emit this->OnEject();
}

void MainToolbarWidget::EjectForceClickedSlot()
{
    emit this->OnEjectForce();
}

void MainToolbarWidget::EjectAllClickedSlot()
{
    emit this->OnEjectAll();
}
