#ifndef ADDPASSWORDCONTROLLER_H
#define ADDPASSWORDCONTROLLER_H

#include "operations/BackgroundJob.h"

class ContainerDescriptor;
class AddPasswordWorker;
class ContainerAccessDialog;
class AssignPasswordDialog;
class QtPwdGetGlue;

//! this object belongs to UI thread
class AddPasswordController : public BackgroundJob
{
    Q_OBJECT
public:
    explicit AddPasswordController(QWidget *parentWidget, ContainerDescriptor *descriptor);
    ~AddPasswordController();

protected:
    Worker* getWorker();

protected slots:
    void on_finished(bool success);

private:
    AddPasswordWorker *worker;

    ContainerAccessDialog *mainAccessDialog;
    QtPwdGetGlue *mainGlue;

    ContainerAccessDialog *addAccessDialog;
    QtPwdGetGlue *addGlue;

    AssignPasswordDialog  *assignPasswordDlg;
    QtPwdGetGlue *assignGlue;
};

#endif // ADDPASSWORDCONTROLLER_H
