#include <QDebug>

#include "BackupHeaderController.h"
#include "BackupHeaderWorker.h"
#include "entity/containerdescriptor.h"
#include "container/BCFileChannel.h"
#include "dialogs/BackupHeaderDialog.h"
#include "QtCertlibProgressActor.h"

BackupHeaderController::BackupHeaderController(QWidget *parentWidget, ContainerDescriptor *d) :
    BackgroundJob(parentWidget, d), worker(0)
{
    worker = new BackupHeaderWorker();

    worker->m_containerFileChannel = new BCFileChannel(descriptor->GetPath().toStdString().c_str());
    worker->cProgressActor = new QtCertlibProgressActor(worker);
    connect(worker->cProgressActor, SIGNAL(progress(QString,int,int)), this, SIGNAL(progress(QString,int,int)));

    backupHeaderDialog = new BackupHeaderDialog(parentWidget, &worker->headerParams);
    backupHeaderDialog->setFilename(descriptor->GetPath());
    mainGlue = new QtPwdGetGlue(this, backupHeaderDialog, &worker->mainPasswordGetter);
}


void BackupHeaderController::on_finished(bool success)
{
    qDebug() << "BackupHeaderController::on_finished(" << success << ")";

    emit finished(success);
}

Worker* BackupHeaderController::getWorker()
{
    return worker;
}
