#ifndef CREATECONTROLLER_H
#define CREATECONTROLLER_H

#include "operations/BackgroundJob.h"

class CreationWorker;
class OpenedKeyfiles;
class ContainerDescriptor;
class ContainerListModel;
class ContainerCreateDialog;
class QTimer;


class CreationController : public BackgroundJob
{
    Q_OBJECT
public:
    explicit CreationController(QWidget *parentWidget, ContainerDescriptor *d, ContainerCreateDialog *dlg);
    ~CreationController();

public slots:
    void on_finished(bool success);


protected:
    Worker* getWorker();

protected slots:
    void onCancelation();
    void onNeedToUpdateProgress();

private:
    CreationWorker *worker;
    ContainerCreateDialog *creationDialog;
    bool dmIsListening;
    QTimer *progressUpdateTimer;
};

#endif // CREATECONTROLLER_H
