#include <QDebug>

#include "CreationWorker.h"
#include "container/BCFileChannel.h"
#include "QtBCTool.h"

void CreationWorker::on_entry_point()
{
    qDebug() << "   >>> CreationWorker::on_entry_point()";

    m_containerFileChannel = new BCFileChannel(createPwdGet.getContainerContext().path);
    bc_file_mode file_mode = kBCFileMode_ReadWrite | kBCFileMode_Exclude;
    m_mainVolumeHelper = new BCHelperContext(m_containerFileChannel, file_mode, &createPwdGet);

    bool isCreated = bctool->Create(m_mainVolumeHelper, &createParams, &mountParams, &progress);

    // signal main (UI) thread
    finished(isCreated);
}

