#ifndef CREATIONWORKER_H
#define CREATIONWORKER_H

#include "Worker.h"
#include "bctool.h"
#include "QtPwdGet.h"

/**
 * @brief Container creation worker object (background-thread side)
 */
class CreationWorker : public Worker
{
    Q_OBJECT
public:
    // explicit CreationWorker();

    struct Progress: public BCToolCreationProgress
    {
        Progress() : percent(0) {}
        
        int func(bc_u64 nbytes, bc_u64 total)
        {
            if (m_canceled)
                return 0;

            percent = nbytes / total * 100.0;
            return 1;
        }
        
        int percent;
    };

    QtPwdGet createPwdGet;

    BCToolCreateParams createParams;

    // optionally we can mount a container
    BCToolMountParams mountParams;

    Progress progress;

public slots:
    void on_entry_point();
};

#endif // CREATIONWORKER_H
