#include <QDebug>

#include "DecryptHeaderController.h"
#include "DecryptHeaderWorker.h"
#include "entity/containerdescriptor.h"
#include "container/BCFileChannel.h"
#include "dialogs/ContainerAccessDialog.h"
#include "QtCertlibProgressActor.h"


DecryptHeaderController::DecryptHeaderController(QWidget *parentWidget, ContainerDescriptor *d) :
    BackgroundJob(parentWidget, d), worker(0)
{
    worker = new DecryptHeaderWorker();

    worker->m_containerFileChannel = new BCFileChannel(descriptor->GetPath().toStdString().c_str());
    worker->cProgressActor = new QtCertlibProgressActor(worker);
    connect(worker->cProgressActor, SIGNAL(progress(QString,int,int)), this, SIGNAL(progress(QString,int,int)));

    mainAccessDialog = new ContainerAccessDialog(parentWidget);
    mainAccessDialog->setFilename(descriptor->GetPath());
    mainGlue = new QtPwdGetGlue(this, mainAccessDialog, &worker->mainPasswordGetter);
}

void DecryptHeaderController::on_finished(bool success)
{
    qDebug() << "DecryptHeaderController::on_finished(" << success << ")";

    if (success)
        descriptor->update();  // container file was changed, need to re-read

    emit finished(success);
}

Worker* DecryptHeaderController::getWorker()
{
    return worker;
}

