#ifndef HIDDENCREATECONTROLLER_H
#define HIDDENCREATECONTROLLER_H

#include "operations/BackgroundJob.h"

class ContainerDescriptor;
class HiddenCreateWorker;
class ContainerAccessDialog;
class HiddenCreateDialog;
class AssignPasswordDialog;
class QMainWindow;
class QtPwdGetGlue;

class HiddenCreateController : public BackgroundJob
{
    Q_OBJECT
public:
    explicit HiddenCreateController(QWidget *parentWidget, ContainerDescriptor *descriptor);
    ~HiddenCreateController();

signals:
    
public slots:

    //! password is entered for main part, free spacemap was get
    void onFreeSpaceMapChanged();

    //! hidden part created or error occured on some step
    void on_finished(bool success);

protected:
    Worker* getWorker();


private:
    HiddenCreateWorker *worker;

    HiddenCreateDialog    *hiddenCreateDlg;

    ContainerAccessDialog *mainAccessDialog;
    QtPwdGetGlue *mainGlue;

    ContainerAccessDialog *existingHiddenAccessDialog;
    QtPwdGetGlue *existingGlue;

    AssignPasswordDialog  *assignPasswordDlg;
    QtPwdGetGlue *assignGlue;

private slots:

    void onCanceled();
};

#endif // HIDDENCREATECONTROLLER_H
