#ifndef HIDDENCREATEWORKER_H
#define HIDDENCREATEWORKER_H

#include "Worker.h"
#include "bctool.h"
#include "QtPwdGet.h"

class HiddenCreateWorker : public Worker
{
    Q_OBJECT
public:
    explicit HiddenCreateWorker();
    ~HiddenCreateWorker();

    QtPwdGet    mainPwdGet;
    QtPwdGet    existingHiddenPwdGet;
    QtPwdGet    newHiddenPwdGet;

    BCToolCreateParams  createParams;

    // we use it twice:
    // 1. mount main part, get free space
    // 2. (optionaly) mount created hidden part
    BCToolMountParams   mountParams;

    /** Initially it is free space map of main part.
     * Then existing hidden parts will be substracted.
     * Finaly it will be resized to specified size before new hidden part creation.
     */
    SpaceMap *spaceMap;

public slots:
    void on_entry_point();
    void onProtectExistingHiddenPart();
    void onCreateNewHiddenPart();

signals:
    void spacemap_changed();
};

#endif // HIDDENCREATEWORKER_H
