#include <QDir>
#include <QDebug>

#include "MountWorker.h"
#include "QtBCTool.h"
#include "QtCertlibProgressActor.h"


void MountWorker::on_entry_point()
{
    qDebug() << "   >>> MountWorker::on_entry_point()";

    bc_file_mode file_mode = kBCFileMode_Exclude;
    file_mode |= (mountParams.mountReadOnly)? kBCFileMode_Read : kBCFileMode_ReadWrite;

    m_containerFileChannel = new BCFileChannel(mountParams.filename.c_str());
    m_mainVolumeHelper = new BCHelperContext(m_containerFileChannel, file_mode, &mountPwdGet);
    m_mainVolumeHelper->progressActor = cProgressActor;

    bool isMounted = bctool->Mount(*m_mainVolumeHelper, &mountParams);

    // signal main (UI) thread
    finished(isMounted);
}
