#include <QDebug>
#include <QFile>

#include "model/qt_helpers.h"
#include "QtBCTool.h"


QtBCTool::QtBCTool(QObject *parent) :
    QObject(parent)
{
}


void QtBCTool::volumeInfoUpdatedHook()
{
    emit containerInfoUpdated();
}


//! Show yes/no dialog
bool QtBCTool::AskUser(const char *question, bool defaultAnswer)
{
    qDebug() << "QtBCTool: ask a question: " << question;

    emit needAnswer(question, defaultAnswer);

    user_answer_semaphore.acquire();

    qDebug() << "QtBCTool: user answer is " << recieved_answer;
    return recieved_answer;
}

void QtBCTool::answerReceived(bool answer)
{
    recieved_answer = answer;
    user_answer_semaphore.release();
}

void QtBCTool::messageCallback_(bctool_msg_level level, const char *msg)
{
    char c = '?';
    if (level >= 0 && level <= 3) {
        const char mm[] = "DIWE";  // Debug, Info, Warning, Error
        c = mm[level];
    }

    qDebug() << "QtBCTool: message:" << c << ":" << msg;

    if (level > kBCTool_Debug) {
        emit showMessage(static_cast<int>(level), msg);
    }
}

bool QtBCTool::generateRandom(bool strong, bc_u8 *out, size_t size)
{
    // TODO: when 'strong' == true
    //         read from /dev/urandom with dialog
    //         suggesting to do some activity
    //         if this read blocks

    QFile file("/dev/urandom");
    QByteArray bytes = file.read(size);
    memcpy(out, bytes.data(), size);
    return true;
}

