#ifndef QTBCTOOL_H
#define QTBCTOOL_H

#include <QObject>
#include <QSemaphore>

#include "bctool.h"

class QtBCTool : public QObject, public BCTool
{
    Q_OBJECT
public:
    explicit QtBCTool(QObject *parent = 0);

    //! unblock waiting for answer from user
    void answerReceived(bool answer);

    bool AskUser(const char *question, bool defaultAnswer);

    void messageCallback_(bctool_msg_level level, const char *msg);

    bool generateRandom(bool strong, bc_u8 *out, size_t size);

    void volumeInfoUpdatedHook();

signals:
    //! BCVolumeInfo was updated with decoded information (encrypted header decoded)
    void containerInfoUpdated();

    //! Show to user yes/no dialog
    void needAnswer(QString question, bool defaultAnswer);

    void showMessage(int level, QString msg);

private:
    QSemaphore user_answer_semaphore;
    bool recieved_answer;
};

#endif // QTBCTOOL_H
