#include <QDebug>

#include "QtCertlibProgressActor.h"

QtCertlibProgressActor::QtCertlibProgressActor(QObject *parent) :
    QObject(parent)
    , m_mainBlockLimit(0)
    , m_extBlockLimit(0)
    , m_progress(0)
{
}


void QtCertlibProgressActor::init(int value0, int value1)
{
    // qDebug() << "PROGRESS: Entry of " << Q_FUNC_INFO;

    m_mainBlockLimit = value0;
    m_extBlockLimit = value1;
    // emit num_of_steps(m_mainBlockLimit);
}


int QtCertlibProgressActor::func(const char * _message, int value0, int value1)
{
    // qDebug() << "PROGRESS: Entry of " << Q_FUNC_INFO << value0 << value1;

    if (m_progress == 0) {
        // emit started();
    }

    if (value0 == 1) {
        // emit stopped();
        m_progress = 0;
        // qDebug() << "PROGRESS: func(): return 0 (stopped)";
        return 0;
    }

    ++m_progress;

    if (m_progress == m_mainBlockLimit) {
        // continue beyond main slots
        // emit trying_extra_steps();
        // emit num_of_steps(m_extBlockLimit);
    }

    if (m_extBlockLimit > m_mainBlockLimit && m_progress > m_extBlockLimit) {
        // qDebug() << "PROGRESS: func(): return 1";
        return 1;
    }

    QString text = (_message)? QString(_message) : QString();
    int max = (m_progress > m_mainBlockLimit)? m_extBlockLimit : m_mainBlockLimit;

    emit progress(text, m_progress, max);

    int ret = (m_bCancelled)? 1 : 0;
    // qDebug() << "PROGRESS: func(): return " << ret;
    return ret;
}


void QtCertlibProgressActor::on_canceled()
{
    m_bCancelled = true;
}

