#ifndef QTPWDGET_H
#define QTPWDGET_H

#include <QObject>
#include <QSemaphore>

#include "container/cPwdGet.h"

class OpenedKeyfiles;
class BCFileChannel;


class QtPwdGet : public QObject, public cPwdGet
{
    Q_OBJECT
public:
    explicit QtPwdGet(QObject *parent = 0);
    ~QtPwdGet();

    // callback from multi-lib, emits 'needPassword' to communicate with controller in UI-thread
    BCContainerResult getPassword(bool prevFailed);

    //! direct cross-thread call. Make sure you are not modifing shared data after this call
    bool setPasswordBundle(QString pass, QStringList keyfiles, QString external_header = "");

    QString getLastError() const;

signals:
    void needPassword(bool prev_failed);

private:
    QSemaphore password_semaphore;
    OpenedKeyfiles *opened_key_files;
    BCFileChannel *external_header_channel;
    QString last_error;
};

#endif // QTPWDGET_H
