#include <QDebug>

#include "RemovePasswordController.h"
#include "RemovePasswordWorker.h"
#include "entity/containerdescriptor.h"
#include "container/BCFileChannel.h"
#include "dialogs/ContainerAccessDialog.h"
#include "dialogs/AssignPasswordDialog.h"
#include "QtCertlibProgressActor.h"


RemovePasswordController::RemovePasswordController(QWidget *parentWidget, ContainerDescriptor *d) :
    BackgroundJob(parentWidget, d), worker(0)
{
    worker = new RemovePasswordWorker();

    worker->m_containerFileChannel = new BCFileChannel(descriptor->GetPath().toStdString().c_str());
    worker->cProgressActor = new QtCertlibProgressActor(worker);
    connect(worker->cProgressActor, SIGNAL(progress(QString,int,int)), this, SIGNAL(progress(QString,int,int)));

    mainAccessDialog = new ContainerAccessDialog(parentWidget);
    mainAccessDialog->setFilename(descriptor->GetPath());
    mainAccessDialog->enableAskMore();
    mainGlue = new QtPwdGetGlue(this, mainAccessDialog, &worker->mainPasswordGetter);

    addAccessDialog = new ContainerAccessDialog(parentWidget);
    addAccessDialog->setFilename(descriptor->GetPath());
    addGlue = new QtPwdGetGlue(this, addAccessDialog, &worker->additionalPasswordGetter);
}

void RemovePasswordController::on_finished(bool success)
{
    qDebug() << "RemovePasswordController::on_finished(" << success << ")";

    emit finished(success);
}

Worker* RemovePasswordController::getWorker()
{
    return worker;
}

