#include <QDebug>

#include "Worker.h"
#include "QtBCTool.h"
#include "model/qt_helpers.h"


Worker::Worker() :
    QObject(0)
    , cProgressActor(0)
    , m_containerFileChannel(0)
    , m_mainVolumeHelper(0)
{
    bctool = new QtBCTool(this);
    connect(bctool, SIGNAL(containerInfoUpdated()), this, SLOT(onContainerInfoUpdated()));
}

Worker::~Worker()
{
    // delete bctool; // no need- QObject will delete its children

    if (m_containerFileChannel)
        delete m_containerFileChannel;

    if (m_mainVolumeHelper)
        delete m_mainVolumeHelper;

    qDebug() << "Worker destroyed";
}


void Worker::onContainerInfoUpdated()
{
    qDebug() << "BCPrepareContainerForOperation(): main part opened";

    m_mainVolumeHelper->header->mainVolumeInfo(&m_volumeInfo);

    // signal to UI thread to update ContainerDescriptor
    emit volume_info_updated();
}

