#ifndef WORKER_H
#define WORKER_H

#include <QObject>

#include "container/keygen.h"

class QtBCTool;
class BCFileChannel;
class BCHelperContext;
class QtCertlibProgressActor;
class cPwdGet;

/**
 * @brief Slots of this object will be executed in new thread.
 * This object must not have parent QObject because it is moved
 * with moveToThread()
 */
class Worker : public QObject
{
    Q_OBJECT
public:
    explicit Worker();
    virtual ~Worker();

    QtBCTool *bctool;

    BCVolumeInfo m_volumeInfo;

    QtCertlibProgressActor *cProgressActor;

    BCFileChannel       *m_containerFileChannel;

public slots:
    virtual void on_entry_point() = 0;

protected:
    BCHelperContext     *m_mainVolumeHelper;

signals:
    void volume_info_updated();
    void finished(bool success);

private slots:
    void onContainerInfoUpdated();
};

#endif // WORKER_H
