#include "FilesystemUtils.h"

#include <sys/statfs.h>
#include <string.h>
#include <libgen.h>

uint64_t FilesystemUtils::getFreeSpace(const std::string &path)
{
    char buf[4096];
    strncpy(buf, path.c_str(), sizeof(buf));
    const char *dd = dirname(buf);

    struct statfs ss;

    if (statfs(dd, &ss) == (-1)) {
        return 0;
    }

    return ss.f_bavail * 4096;
}
