#ifndef STRINGUTILS_H
#define STRINGUTILS_H

#include <string>
#include <stdint.h>

namespace StringUtils
{

//! Returns string with container size formatted with appropriate size units.
std::string humanSizeString(uint64_t size);

//! Converts string of format ex. "10M" to size in bytes.
uint64_t   sizeStringToBytes(const char *string);

//! time in seconds to human readable interval, ex. 343.3 sec => "about 5 min"
std::string humanTimeInterval(double seconds);

};

#endif // STRINGUTILS_H
