/*
 * Copyright 2012 Jetico, Inc. All rights reserved.
 * BestCrypt container reencryption interface.
 */

#include <signal.h>

#include "bctool.h"
#include "container/BCFileChannel.h"

bool BCTool::Reencrypt(const char *file, const char *algName, const char *modeName)
{
    ShowError("Reencrypt is not implemented in current version.");
    ShowInfo("Instead just create a new container and move your data into it.");
    return false;

    if (!BCTool::WantChange(file))
        return false;

    if (!algName) {
        this->ShowError("Please specify algorithm name.\n");
        return false;
    }

    if (!modeName) {
        this->ShowError("Please specify encryption mode name.\n");
        return false;
    }

    if (this->CheckContainerInUse(file)) {
        return false;
    }

    // get specified algorithm and mode
    BCAlgInfo alg;
    if (kBCCipher_Success != BCKernelLookupAlgByName(algName, &alg)) {
        this->ShowError("Unknown algorithm: %s.\n", algName);
        return false;
    }

    bc_mode_id modeid = BCKernelModeId(modeName);

    if (!BCKernelIsModeSupported(&alg, modeid)) {
        this->ShowError("Algorithm %s does not support mode %s\n", algName, modeName);
        return false;
    }

    if (!this->AskUser("Warning: you are about to reencrypt your container.\n"
                "Please note that any additional passwords and hidden parts (if any) "
                       "will be lost. Are you sure you want to continue? (y/[n])", false))
    {
        this->ShowInfo("Reencryption cancelled.\n");
        return false;
    }

    BCFileChannel fch(file);
    int error = BCReencrypt(&fch, NULL, alg.id, modeid, NULL, NULL);
    if(kBCContainer_Cancelled == error) {
        this->ShowInfo("Reencryption cancelled.\n");
    } else if (kBCContainer_Success != error) {
        this->ShowError("Failed to reencrypt container.\n");
        return false;
    } /*else {
        this->ShowMessage("Container successfully reencrypted.\n");
    }*/

    return true;
}
