#ifndef CLI_USER_INTERACTION_H
#define CLI_USER_INTERACTION_H

#include "bctool.h"
#include "certificate/CertificateLib/progressActor.h"

class CLI_BCTool: public BCTool
{
    bool AskUser(const char *msg, bool defaultAnswer);

    void messageCallback_(bctool_msg_level level, const char *msg);

    bool generateRandom(bool strong, bc_u8 *out, size_t size);
};


class PwdGet_Common_CLI: public cPwdGet
{
public:
    PwdGet_Common_CLI(const char *query = "")
        : cPwdGet(query), opened_key_files(0) {}

    ~PwdGet_Common_CLI()
    {
        if (opened_key_files)
            delete opened_key_files;
    }

    BCContainerResult getPassword ( bool prevFailed );

    void setKeyFiles(strings_t keyfiles);

private:

    OpenedKeyfiles *opened_key_files;
};


class CLI_CertlibProgressActor : public cProgressActor
{
public:
    CLI_CertlibProgressActor();

    void init (int value0, int value1);

    int func(const char * name, int value0, int value1);

private:
    unsigned int m_mainBlockLimit;
    unsigned int m_extBlockLimit;
    unsigned int m_progress;
};

#endif // CLI_USER_INTERACTION_H
